with Interfaces; use Interfaces;

package body CORBA_Repository_Root_ExceptionDef_Hash is

   P : constant array (0 .. 4) of Natural :=
     (2, 4, 8, 9, 13);

   T1 : constant array (0 .. 4) of Unsigned_8 :=
     (49, 4, 48, 14, 51);

   T2 : constant array (0 .. 4) of Unsigned_8 :=
     (52, 68, 21, 25, 52);

   G : constant array (0 .. 76) of Unsigned_8 :=
     (0, 17, 0, 0, 0, 0, 0, 0, 0, 25, 0, 0, 4, 9, 0, 5, 4, 37, 0, 0, 0, 27,
      0, 15, 16, 19, 0, 14, 0, 12, 0, 0, 0, 6, 0, 11, 0, 19, 24, 0, 34, 8,
      1, 35, 3, 0, 17, 10, 10, 0, 0, 9, 0, 16, 9, 0, 16, 13, 0, 3, 8, 0, 33,
      0, 0, 0, 0, 0, 9, 0, 23, 0, 0, 18, 0, 2, 0);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 77;
         F2 := (F2 + Natural (T2 (K)) * J) mod 77;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 38;
   end Hash;

end CORBA_Repository_Root_ExceptionDef_Hash;
